//COPYRIGHT(C) 1998 BY JASON WINNEBECK.  YOU MAY FREELY DISTRIBUTE THIS
//SOURCE AND ACCOMPANYING FILES AS LONG AS YOU STILL KEEP THEM ALL TOGETHER,
//YOU DO NOT MODIFY THEM, AND YOU DON'T CLAIM THEM AS YOUR OWN WORK.

//JETFIGHT GLOBALS FILE.  Misc procs and global vars

#include "jetfight.h"

// define all global variables here
char joyinst = 0;

const float a2rad = PI / 180.0;

DATAFILE *data;

SoundSystem Sound;
VideoSystem Video;
Particles Parts;
SpritesSystem Sprites;
WeaponSystem Weapons;
ControlSystem Control;
PlayerSystem Player;
EnemySystem Enemies;
WorldSystem World;

volatile unsigned int fps;

// ***Game Keys***
int c_left = KEY_LEFT;
int c_right = KEY_RIGHT;
int c_up = KEY_UP;
int c_down = KEY_DOWN;
int c_shoot = KEY_SPACE;
int c_nav = KEY_N;
int c_nway = KEY_OPENBRACE;
int c_pway = KEY_CLOSEBRACE;
int c_auto = KEY_A;

float FindAngle(float x2, float y2, float x1, float y1) { //angle of seg (Origin)-(destination)
  y1 = -y1;
  y2 = -y2;
  if (x1 == x2)
    if (y2 > y1)
      return 180.0;
    else
      return 0.0;

  float tempresult = atan((y2 - y1) / (x2 - x1)) / a2rad;

  // yes I know there is NO handler for 270.0 and 90.0 speicifcally
  // but it hasn't hit it so far, and if it does it wouldn't be
  // a major bug (cause 1 frame's worth of inaccuracy)
  if (x1 < x2)
    if (y1 < y2)
      tempresult = -(tempresult - 90.0) + 180.0;
    else
      tempresult = -tempresult + 270.0;
  else if (x1 > x2)
    if (y1 > y2)
      tempresult = -(tempresult - 90.0);
    else
      tempresult = -tempresult + 90.0;

  return tempresult;
}

float FindDirection(float a1, float a2) { //finds best path to a2 from a1
  //+ = clockwise - = counterclockwise  returns direction n distance
  float temp = a2 - a1;
  if (temp > 180.0)
    temp = a2 - 360.0 - a1;
  else if (temp < -180.0)
    temp = a2 + 360.0 - a1;

  return temp;
}

// ***MENUING GLOBALS
int ret = -1;

int SetRet(void *dp3, int d2) {
  Sound.MouseClick(128);
  ret = d2;
  return D_O_K;
}

int d_check_exit(int msg, DIALOG *d, int c) {
  if (msg == MSG_IDLE)
    if (ret != -1)
      return D_CLOSE;
    else
      return D_O_K;

  return D_O_K;
}

// *******CONVERSION PROCS

unsigned char AtoD(unsigned char a) {
  switch (a) {
    case 1:
      return water1;
    case 2:
      return water2;
    case 3:
      return water3;
    case 4:
      return water4;
    case 5:
      return water5;
    case 6:
      return water6;
    case 7:
      return tshore1;
    case 8:
      return tshore2;
    case 9:
      return tshore3;
    case 10:            // *** 10 LSHORE1
      return urshore1;
    case 11:
      return urshore2;
    case 12:
      return urshore3;
    case 13:
      return rshore1;
    case 14:
      return rshore2;
    case 15:
      return rshore3;
    case 16:
      return brshore1;
    case 17:
      return brshore2;
    case 18:
      return brshore3;
    case 19:
      return bshore1;
    case 20:            // *** 20 URSHORE1
      return bshore2;
    case 21:
      return bshore3;
    case 22:
      return blshore1;
    case 23:
      return blshore2;
    case 24:
      return blshore3;
    case 25:
      return lshore1;
    case 26:
      return lshore2;
    case 27:
      return lshore3;
    case 28:
      return ulshore1;
    case 29:
      return ulshore2;
    case 30:            // *** 30 BEACH3
      return ulshore3;
    case 31:
      return beach1;
    case 32:
      return beach2;
    case 33:
      return beach3;
    case 34:
      return beach4;
    case 35:
      return beach5;
    case 36:
      return beach6;
    case 37:
      return tgrass1;
    case 38:
      return tgrass2;
    case 39:
      return tgrass3;
    case 40:            // *** 40 ULGRASS1
      return urgrass1;
    case 41:
      return urgrass2;
    case 42:
      return urgrass3;
    case 43:
      return rgrass1;
    case 44:
      return rgrass2;
    case 45:
      return rgrass3;
    case 46:
      return brgrass1;
    case 47:
      return brgrass2;
    case 48:
      return brgrass3;
    case 49:
      return bgrass1;
    case 50:            // *** 50 BGRASS2
      return bgrass2;
    case 51:
      return bgrass3;
    case 52:
      return blgrass1;
    case 53:
      return blgrass2;
    case 54:
      return blgrass3;
    case 55:
      return lgrass1;
    case 56:
      return lgrass2;
    case 57:
      return lgrass3;
    case 58:
      return ulgrass1;
    case 59:
      return ulgrass2;
    case 60:            // *** 60 ULGRASS2
      return ulgrass3;
    case 61:
      return grass1;
    case 62:
      return grass2;
    case 63:
      return grass3;
    case 64:
      return grass4;
    case 65:
      return grass5;
    case 66:
      return grass6;
/*    case 67:
      return tjungle1;
    case 68:
      return tjungle2;
    case 69:
      return tjungle3;
    case 70:            // *** 70 ULJUNGLE1
      return urjungle1;
    case 71:
      return urjungle2;
    case 72:
      return urjungle3;
    case 73:
      return rjungle1;
    case 74:
      return rjungle2;
    case 75:
      return rjungle3;
    case 76:
      return brjungle1;
    case 77:
      return brjungle2;
    case 78:
      return brjungle3;
    case 79:
      return bjungle1;
    case 80:            // *** 80 BJUNGLE2
      return bjungle2;
    case 81:
      return bjungle3;
    case 82:
      return bljungle1;
    case 83:
      return bljungle2;
    case 84:
      return bljungle3;
    case 85:
      return ljungle1;
    case 86:
      return ljungle2;
    case 87:
      return ljungle3;
    case 88:
      return uljungle1;
    case 89:
      return uljungle2;
    case 90:            // *** 90 ULJUNGLE2
      return uljungle3;
    case 91:
      return jungle1;
    case 92:
      return jungle2;
    case 93:
      return jungle3;
    case 94:
      return jungle4;
    case 95:
      return jungle5;
    case 96:
      return jungle6;*/
    case 97:
      return tbase1;
    case 98:
      return tbase2;
    case 99:
      return twall;
    case 100:
      return urwall;
    case 101:
      return rwall;
    case 102:
      return brwall;
    case 103:
      return bwall;
    case 104:
      return blwall;
    case 105:
      return lwall;
    case 106:
      return ulwall;
    case 107:
      return i1shore1;
    case 108:
      return i1shore2;
    case 109:
      return i1shore3;
    case 110:
      return i2shore1;
    case 111:
      return i2shore2;
    case 112:
      return i2shore3;
    case 113:
      return i3shore1;
    case 114:
      return i3shore2;
    case 115:
      return i3shore3;
    case 116:
      return i4shore1;
    case 117:
      return i4shore2;
    case 118:
      return i4shore3;
    case 119:
      return i1grass1;
    case 120:
      return i1grass2;
    case 121:
      return i1grass3;
    case 122:
      return i2grass1;
    case 123:
      return i2grass2;
    case 124:
      return i2grass3;
    case 125:
      return i3grass1;
    case 126:
      return i3grass2;
    case 127:
      return i3grass3;
    case 128:
      return i4grass1;
    case 129:
      return i4grass2;
    case 130:
      return i4grass3;
    default:
      return workfast;
  };

  return workfast;
}

unsigned char DtoAconv(unsigned char d) { //Keep in mind this returns the result + 1;
  switch (d) {
    case water1:
      return 2;
    case water2:
      return 3;
    case water3:
      return 4;
    case water4:
      return 5;
    case water5:
      return 6;
    case water6:
      return 7;
    case tshore1:
      return 8;
    case tshore2:
      return 9;
    case tshore3:
      return 10;          // *** 10 LSHORE1
    case urshore1:
      return 11;
    case urshore2:
      return 12;
    case urshore3:
      return 13;
    case rshore1:
      return 14;
    case rshore2:
      return 15;
    case rshore3:
      return 16;
    case brshore1:
      return 17;
    case brshore2:
      return 18;
    case brshore3:
      return 19;
    case bshore1:
      return 20;          // *** 20 URSHORE1
    case bshore2:
      return 21;
    case bshore3:
      return 22;
    case blshore1:
      return 23;
    case blshore2:
      return 24;
    case blshore3:
      return 25;
    case lshore1:
      return 26;
    case lshore2:
      return 27;
    case lshore3:
      return 28;
    case ulshore1:
      return 29;
    case ulshore2:
      return 30;          // *** 30 BEACH3
    case ulshore3:
      return 31;
    case beach1:
      return 32;
    case beach2:
      return 33;
    case beach3:
      return 34;
    case beach4:
      return 35;
    case beach5:
      return 36;
    case beach6:
      return 37;
    case tgrass1:
      return 38;
    case tgrass2:
      return 39;
    case tgrass3:
      return 40;          // *** 40 ULGRASS1
    case urgrass1:
      return 41;
    case urgrass2:
      return 42;
    case urgrass3:
      return 43;
    case rgrass1:
      return 44;
    case rgrass2:
      return 45;
    case rgrass3:
      return 46;
    case brgrass1:
      return 47;
    case brgrass2:
      return 48;
    case brgrass3:
      return 49;
    case bgrass1:
      return 50;          // *** 50 BGRASS2
    case bgrass2:
      return 51;
    case bgrass3:
      return 52;
    case blgrass1:
      return 53;
    case blgrass2:
      return 54;
    case blgrass3:
      return 55;
    case lgrass1:
      return 56;
    case lgrass2:
      return 57;
    case lgrass3:
      return 58;
    case ulgrass1:
      return 59;
    case ulgrass2:
      return 60;          // *** 60 ULGRASS2
    case ulgrass3:
      return 61;
    case grass1:
      return 62;
    case grass2:
      return 63;
    case grass3:
      return 64;
    case grass4:
      return 65;
    case grass5:
      return 66;
    case grass6:
      return 67;
/*    case tjungle1:
      return 68;
    case tjungle2:
      return 69;
    case tjungle3:
      return 70;          // *** 70 ULJUNGLE1
    case urjungle1:
      return 71;
    case urjungle2:
      return 72;
    case urjungle3:
      return 73;
    case rjungle1:
      return 74;
    case rjungle2:
      return 75;
    case rjungle3:
      return 76;
    case brjungle1:
      return 77;
    case brjungle2:
      return 78;
    case brjungle3:
      return 79;
    case bjungle1:
      return 80;          // *** 80 BJUNGLE2
    case bjungle2:
      return 81;
    case bjungle3:
      return 82;
    case bljungle1:
      return 83;
    case bljungle2:
      return 84;
    case bljungle3:
      return 85;
    case ljungle1:
      return 86;
    case ljungle2:
      return 87;
    case ljungle3:
      return 88;
    case uljungle1:
      return 89;
    case uljungle2:
      return 90;          // *** 90 ULJUNGLE2
    case uljungle3:
      return 91;
    case jungle1:
      return 92;
    case jungle2:
      return 93;
    case jungle3:
      return 94;
    case jungle4:
      return 95;
    case jungle5:
      return 96;
    case jungle6:
      return 97;*/
    case tbase1:
      return 98;
    case tbase2:
      return 99;
    case twall:
      return 100;
    case urwall:
      return 101;
    case rwall:
      return 102;
    case brwall:
      return 103;
    case bwall:
      return 104;
    case blwall:
      return 105;
    case lwall:
      return 106;
    case ulwall:
      return 107;
    case i1shore1:
      return 108;
    case i1shore2:
      return 109;
    case i1shore3:
      return 110;
    case i2shore1:
      return 111;
    case i2shore2:
      return 112;
    case i2shore3:
      return 113;
    case i3shore1:
      return 114;
    case i3shore2:
      return 115;
    case i3shore3:
      return 116;
    case i4shore1:
      return 117;
    case i4shore2:
      return 118;
    case i4shore3:
      return 119;
    case i1grass1:
      return 120;
    case i1grass2:
      return 121;
    case i1grass3:
      return 122;
    case i2grass1:
      return 123;
    case i2grass2:
      return 124;
    case i2grass3:
      return 125;
    case i3grass1:
      return 126;
    case i3grass2:
      return 127;
    case i3grass3:
      return 128;
    case i4grass1:
      return 129;
    case i4grass2:
      return 130;
    case i4grass3:
      return 131;
    default:
      return 1;
  };

  return 1;
}
