//COPYRIGHT(C) 1998 BY JASON WINNEBECK.  YOU MAY FREELY DISTRIBUTE THIS
//SOURCE AND ACCOMPANYING FILES AS LONG AS YOU STILL KEEP THEM ALL TOGETHER,
//YOU DO NOT MODIFY THEM, AND YOU DON'T CLAIM THEM AS YOUR OWN WORK.

#include "jetfight.h"
#include "jrnd.h"

unsigned char WaterBlock[3][3]= {{water1,   water1,  water1  },
                                 {water1,   water1,  water1  },
                                 {water1,   water1,  water1  }};

unsigned char BeachBlock[3][3]= {{ulshore1, tshore1, urshore1},
                                 { lshore1, beach1,  rshore1 },
                                 {blshore1, bshore1, brshore1}};

unsigned char GrassBlock[3][3]= {{ulgrass1, tgrass1, urgrass1},
                                 { lgrass1, grass1,  rgrass1 },
                                 {blgrass1, bgrass1, brgrass1}};

unsigned char GetRandTile(unsigned char image);
  //gets a random tile given the first of the set
void MapBlit(unsigned char x2, unsigned char y2, unsigned char Block[3][3]);
  //"blits" a Block onto the map
unsigned char Combine(unsigned char src, unsigned char dest);
unsigned char ShoreCombine(unsigned char src, unsigned char dest);

unsigned char doagain = 0, xagain = 0, yagain = 0; //for recursion

void LayTiles(unsigned char x, unsigned char y, unsigned char image) { //Lays tiles
  if (x)
    x--;  //decrement x so that the mouse is in the center if it won't underflow
  if (y)
    y--;  //y also
  if (x > mapx - 3) //range check x,y
    x = mapx - 3;
  if (y > mapy - 3)
    y = mapy - 3;

  switch (image) { //Copy the image
    case water1:
      MapBlit(x, y, WaterBlock);
      break;
    case grass1:
      MapBlit(x, y, GrassBlock);
      break;
    case beach1:
      MapBlit(x, y, BeachBlock);
      break;
  }

  if (doagain) {
    doagain = 0;
    LayTiles(xagain, yagain, image);
  }
}

unsigned char GetRandTile(unsigned char image) {//gets a random tile given the first of the set
  switch(image) {
    case water1:
    case beach1:
    case grass1:
    //case jungle1:
      return image + getrnd(6);
    case workfast:
      return image;
    default:
      return image + getrnd(3);
  }
}

void MapBlit(unsigned char x2, unsigned char y2, unsigned char Block[3][3]) { //"blits" a Block onto the map
  for (short x=x2; x<x2+3; x++)
    for (short y=y2; y<y2+3; y++) {
      World.AddTile(x, y, Combine(World.GetTile(x, y), Block[y-y2][x-x2]));
      if (doagain == 1) {
        doagain = 2;
        xagain = x;
        yagain = y;
      }
    }
}

unsigned char Combine(unsigned char src, unsigned char dest) {
  return ShoreCombine(src, dest);
}

// ******SHORE COMBINES

inline int ShoreSolid(unsigned char tile) {  //is this a solid tile?
  return (tile == beach1);
}

inline int ShoreSide(unsigned char tile) {   //is this tile a side tile?
  return ((tile == tshore1) || (tile == rshore1) || (tile == bshore1) || (tile == lshore1));
}

inline int ShoreCorner(unsigned char tile) { //is this tile a corner tile?
  return ((tile == urshore1) || (tile == brshore1) || (tile == blshore1) || (tile == ulshore1));
}

inline int ShoreInside(unsigned char tile) { //is this tile an inside tile?
  return ((tile == i1shore1) || (tile == i2shore1) || (tile == i3shore1) || (tile == i4shore1));
}

unsigned char SideCombine(unsigned char src, unsigned char dest) { //combines 2 sides
  switch (src) {
    case tshore1:
      switch (dest) {
        case rshore1:
          return i3shore1;
        case bshore1:
          return beach1;
        case lshore1:
          return i2shore1;
      }
      break;
    case rshore1:
      switch (dest) {
        case tshore1:
          return i3shore1;
        case bshore1:
          return i4shore1;
        case lshore1:
          return beach1;
      }
      break;
    case bshore1:
      switch (dest) {
        case tshore1:
          return beach1;
        case rshore1:
          return i4shore1;
        case lshore1:
         return i1shore1;
      }
      break;
    case lshore1:
      switch (dest) {
        case tshore1:
          return i2shore1;
        case rshore1:
          return beach1;
        case bshore1:
          return i1shore1;
      }
      break;
  }
  return dest;
}

unsigned char ShoreCombine(unsigned char src, unsigned char dest) {
  if (src == dest) //if the tiles are the same, then it's pretty easy ain't it?
    return dest;

  if (ShoreSolid(src) || ShoreSolid(dest)) //solid tiles take precedence
    return beach1;

  if (ShoreInside(dest))      //inside tiles have precedence
    return src;
  else if (ShoreInside(src))
    return dest;

  if (ShoreSide(src) && ShoreSide(dest)) {//side tiles combine if =
    unsigned char temptile;
    temptile = SideCombine(src, dest);
    if (temptile == beach1) {
      doagain = 1;
      return temptile;
    } else {
      return temptile;
    }
  }

  if (ShoreSide(src)) //side tiles have precedence
    return src;
  else if (ShoreSide(dest))
    return dest;

  return dest;
}

// ***** GRASS COMBINES
