//COPYRIGHT(C) 1998 BY JASON WINNEBECK.  YOU MAY FREELY DISTRIBUTE THIS
//SOURCE AND ACCOMPANYING FILES AS LONG AS YOU STILL KEEP THEM ALL TOGETHER,
//YOU DO NOT MODIFY THEM, AND YOU DON'T CLAIM THEM AS YOUR OWN WORK.

#include <string.h>
#include "jetfight.h"
#include <jpeg.h>
#include <tdgui.h>

//Function Declarations
void MakePointer(BITMAP *image); //Makes the mouse pointer
void DisplayBack(); //Displays title screen background
void TitleScreen(); //Displays the title screen
void Credits();     //Displays the credits screen
void Thanks();      //Displays the thanks screen
void Instructions();//Dipplays the instructions
int PlayGame();     //Plays the main game

//Menus
int MainMenu();
int Options();
void LoadGame();
void SaveGame();

//Menu Helpers
int Quit(void *dp3, int d2);
int d_check_exit(int msg, DIALOG *d, int c);
int SetRet(void *dp3, int d2);
int SetControls();
int d_get_ctrls(int msg, DIALOG *d, int c);

//Menu Vars
char verline[40];
char currkey[40];
int onkey;

//Mouse Data Vars
BITMAP *mptr;

//Timer Function Declarations
volatile char frame = 0;

void fpsproc(...) {
  frame = 1;
}

END_OF_FUNCTION(fpsproc);

void timeproc(...) {
  fps++;
}

END_OF_FUNCTION(timeproc);

int Menus() {
  if (Video.EnterGraphics(32))
    if (Video.EnterGraphics(24))
      return 1;

  mptr = create_bitmap(32, 32);
  clear(mptr);

  MakePointer((BITMAP *)data[mouseptr].dat);
  show_mouse(screen);
  scare_mouse();
  rest(200); //wait for gfx mode to init

  TitleScreen(); //shows title screens
  Credits();     //FUTURE OPTIMIZATION TIP -- use menus.cc globals to store
  Thanks();      //  pointers for the title screen images so no re-load

  do {
    clear_keybuf();
    scare_mouse();
    DisplayBack();
    unscare_mouse();
    MakePointer((BITMAP *)data[mouseptr].dat);

    switch (MainMenu()) {
      case 0:
        destroy_bitmap(mptr);
        return 0;
        break;
      case 1:
        if (Video.EnterGraphics(8))
          return 1;

        PlayGame();

        if (Video.EnterGraphics(32))
          if (Video.EnterGraphics(24))
            return 1;

        break;
      case 2:
        if (MapEdit()) {
          if (Video.EnterGraphics(32))
            Video.EnterGraphics(24);
          bill_init_pal();
          billalert("Map Editor Error!", "Map editor requires a", "1024x768 SVGA display", "&OK", NULL, 'o', NULL);
          return 1;
        }
        break;
      case 3:
        Credits();
        Thanks();
        break;
      case 4:
        Instructions();
        break;
      case 5:
        switch (Options()) {
          case 1:
            LoadGame();
            break;
          case 2:
            SaveGame();
            break;
          case 3:
            SetControls();
            break;
        };
        break;
    };
  } while (TRUE);
}

void MakePointer(BITMAP *image) { //sets up the mouse pointer
  clear(mptr);

  set_palette((RGB *)data[jetfight].dat);
  blit(image, mptr, 0, 0, 0, 0, 32, 32);

  set_mouse_sprite(mptr);
  set_mouse_sprite_focus(9,9);
}

void DisplayBack() {
  RGB temppal[256];
  BITMAP *tempbitmap = create_bitmap(640, 479);
  tempbitmap = load_jpeg("jet32.dat#title", temppal);

  blit(tempbitmap, screen, 0, 0, 0, 0, 640, 479);

  destroy_bitmap(tempbitmap);
}

void TitleScreen() {
  DisplayBack();

  rest(50);
  Sound.Explosion(0);

  textout(screen, font, "Version: ", 0, 472, -1);
  rest(450);
  Sound.Explosion(255);
  textout(screen, font, verno, 72, 472, -1);
  rest(350);
  Sound.Explosion(128);
  textout(screen, font, "Copyright (C) 1998 by Jason Winnebeck", 344, 472, -1);
  rest(50);
  Sound.Explosion(0);

  readkey();
}

void Credits() {
  RGB temppal[256];
  BITMAP *tempbitmap = create_bitmap(640, 480);
  tempbitmap = load_jpeg("jet32.dat#credits", temppal);

  Sound.Applause(0);
  rest(10);
  Sound.Applause(255);
  rest(10);
  Sound.Applause(128);

  blit(tempbitmap, screen, 0, 0, 0, 0, 640, 479);
  textout(screen, font, "Version: ", 0, 472, -1);
  textout(screen, font, verno, 72, 472, -1);
  textout(screen, font, "Copyright (C) 1998 by Jason Winnebeck", 344, 472, -1);

  readkey();

  destroy_bitmap(tempbitmap);
}

void Thanks() {
  RGB temppal[256];
  BITMAP *tempbitmap = create_bitmap(640, 480);
  tempbitmap = load_jpeg("jet32.dat#thanks", temppal);

  Sound.Applause(0);
  rest(10);
  Sound.Applause(255);
  rest(10);
  Sound.Applause(128);

  blit(tempbitmap, screen, 0, 0, 0, 0, 640, 479);
  textout(screen, font, "Version: ", 0, 472, -1);
  textout(screen, font, verno, 72, 472, -1);
  textout(screen, font, "Copyright (C) 1998 by Jason Winnebeck", 344, 472, -1);

  readkey();

  destroy_bitmap(tempbitmap);
}

void Instructions() {
  DisplayBack();
  textout(screen, font, "Version: ", 0, 472, -1);
  textout(screen, font, verno, 72, 472, -1);
  textout(screen, font, "Copyright (C) 1998 by Jason Winnebeck", 344, 472, -1);

  int sl = 8 * 20; //startline

  textout_centre(screen, font, "DEFAULT CONTROLS:", 320, sl, -1);

  textout_centre(screen, font, "  Use arrow keys to turn and control speed", 320, sl+16, -1);
  textout_centre(screen, font, "  Use space bar to shoot (bullets not in yet)", 320, sl+24, -1);
  textout_centre(screen, font, "  Use N to activate the navsystem", 320, sl+32, -1);
  textout_centre(screen, font, "  Use A to let autopilot take over", 320, sl+40, -1);
  textout_centre(screen, font, "  Use [ and ] to change waypoints", 320, sl+48, -1);

  textout_centre(screen, font, "  Joystick moves plane", 320, sl+64, -1);
  textout_centre(screen, font, "  Main trigger shoots bullets", 320, sl+72, -1);

  textout_centre(screen, font, "Print screen key saves a screenshot to screen.pcx", 320, sl+88, -1);

  textout_centre(screen, font, "Pressing ESC exits JetFight alpha", 320, sl+104, -1);
  readkey();
}

int PlayGame() {
  scare_mouse();

  LOCK_FUNCTION(fpsproc);
  LOCK_VARIABLE(frame);
  LOCK_FUNCTION(timeproc);
  LOCK_VARIABLE(fps);

  install_int(fpsproc, 35);

  World.StartMusic();

  while (!key[KEY_ESC]) {
    fps = 0;
    install_int(timeproc, 5);
    while(!frame) {};
    remove_int(timeproc);
    frame = 0;
    Control.Update();
    World.Update();
    Sound.Update();
    Video.Update();
  }

  remove_int(fpsproc);

  Sound.MusicStop();
  Sound.Jet(0, 0, 0);
  Sound.MachineGun(0, 0);

  unscare_mouse();

  return 0;
}

// *********************************
// ************* MENUS *************
// *********************************

int Quit(void *dp3, int d2) {
  Sound.MouseClick(128);
  Sound.Neenee(128);
  if (billalert("Quit", "Really want to quit", "JetFight?", "&Yes", "Cancel", 'y', 27) == 1) {
    Sound.MouseClick(128);
    ret = 0;
    return D_CLOSE;
  } else {
    Sound.MouseClick(128);
    return D_O_K;
  }
}

int d_get_ctrls(int msg, DIALOG *d, int c) {
  switch (msg) {
    case MSG_START:
      strcpy(currkey, "Accelerating");
      break;
    case MSG_IDLE:
      switch (onkey) {
        case 0:
          strcpy(currkey, "Accelerating");
          onkey++;
          return D_REDRAW;
        case 1:
          c_up = readkey() >> 8;
          onkey++;
          strcpy(currkey, "Deccelerating");
          return D_REDRAW;
        case 2:
          c_down = readkey() >> 8;
          onkey++;
          strcpy(currkey, "Turning Left");
          return D_REDRAW;
        case 3:
          c_left = readkey() >> 8;
          onkey++;
          strcpy(currkey, "Turning Right");
          return D_REDRAW;
        case 4:
          c_right = readkey() >> 8;
          onkey++;
          strcpy(currkey, "Shooting");
          return D_REDRAW;
        case 5:
          c_shoot = readkey() >> 8;
          onkey++;
          strcpy(currkey, "Turning on Nav System");
          return D_REDRAW;
        case 6:
          c_nav = readkey() >> 8;
          onkey++;
          strcpy(currkey, "Switching waypoint forward");
          return D_REDRAW;
        case 7:
          c_nway = readkey() >> 8;
          onkey++;
          strcpy(currkey, "Switching waypoint back");
          return D_REDRAW;
        case 8:
          c_pway = readkey() >> 8;
          onkey++;
          strcpy(currkey, "Turning on Autopilot");
          return D_REDRAW;
        case 9:
          c_auto = readkey() >> 8;
          onkey++;
          return D_O_K;
        default:
          return D_CLOSE;
      }
      break;
  }

  return D_O_K;
}

DIALOG cdialog[] = {
  /* (dialog proc)       (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
  {d_billwin_proc,        0,    0,  320,   64,     0,  0,    0,        0,    0,    0,  "Set Controls"},

  {d_get_ctrls,           0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL},

  {d_billctext_proc,    160,   28,    0,    0,     0,  0,    0,        0,    0,    0,  "Press key for:"},
  {d_billctext_proc,    160,   36,    0,    0,     0,  0,    0,        0,    0,    0,  currkey},

  {NULL,                  0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL}
};

int SetControls() {
  unscare_mouse();

  strcpy(currkey, "");
  onkey = 1;
  clear_keybuf();
  centre_dialog(cdialog);
  init_moveable(cdialog);
  do_dialog(cdialog, 0);
  shutdown_moveable(cdialog);

  set_config_int("controls", "accelerate", c_up);
  set_config_int("controls", "deccelerate", c_down);
  set_config_int("controls", "turnleft", c_left);
  set_config_int("controls", "turnright", c_right);
  set_config_int("controls", "shoot", c_shoot);
  set_config_int("controls", "navsystem", c_nav);
  set_config_int("controls", "nextnavpoint", c_nway);
  set_config_int("controls", "prevnavpoint", c_pway);
  set_config_int("controls", "autopilot", c_auto);

  billalert("Tip", "To restore the default controls,", "delete jetfight.cfg.", "&OK", NULL, 'o', NULL);
  Sound.MouseClick(128);

  scare_mouse();

  return D_O_K;
}

int GetScreen(int msg, DIALOG *g, int c) {
  switch (msg) {
    case MSG_KEY:
      BITMAP *bmp;
      PALETTE pal;

      get_palette(pal);
      bmp = create_sub_bitmap(screen, 0, 0, SCREEN_W, SCREEN_H);
      save_bitmap("dump.pcx", bmp, pal);
      destroy_bitmap(bmp);
      return D_O_K;
  }
  return D_O_K;
}

DIALOG mmdialog[] = {
  /* (dialog proc)       (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
  {d_billwin_proc,        0,    0,  320,  320,     0,  0,    0,        0,    0,    0,  verline},

  {d_ex_billbutton_proc,306,    4,   10,   10,     0,  0,    0,        0,    0,    0,  "x", Quit, NULL},

  {d_ex_billbutton_proc, 85,   32,  150,   32,     0,  0,  'p',        0,    0,    1,  "&Play Game", SetRet, NULL},
  {d_ex_billbutton_proc, 85,   80,  150,   32,     0,  0,  'e',        0,    0,    2,  "Map &Editor", SetRet, NULL},
  {d_ex_billbutton_proc, 85,  128,  150,   32,     0,  0,  'c',        0,    0,    3,  "&Credits", SetRet, NULL},
  {d_ex_billbutton_proc, 85,  176,  150,   32,     0,  0,  'i',        0,    0,    4,  "&Instructions", SetRet, NULL},
  {d_ex_billbutton_proc, 85,  224,  150,   32,     0,  0,  'o',        0,    0,    5,  "&Options", SetRet, NULL},
  {d_ex_billbutton_proc, 85,  272,  150,   32,     0,  0,  'q',        0,    0,    0,  "&Quit JetFight", Quit, NULL},

  {d_check_exit,          0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL},
  {GetScreen,             0,    0,    0,    0,     0,  0,  's',        0,    0,    0,  NULL},
  {NULL,                  0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL}
};

DIALOG odialog[] = {
  /* (dialog proc)       (x)   (y)   (w)   (h)   (fg)  (bg)  (key) (flags)  (d1)  (d2)  (dp) */
  {d_billwin_proc,        0,    0,  320,  224,     0,  0,    0,        0,    0,    0,  verline},

  {d_ex_billbutton_proc,306,    4,   10,   10,     0,  0,    0,        0,    0,    0,  "x", SetRet, NULL},

  {d_ex_billbutton_proc, 85,   32,  150,   32,     0,  0,  'l',        0,    0,    1,  "&Load Game", SetRet, NULL},
  {d_ex_billbutton_proc, 85,   80,  150,   32,     0,  0,  's',        0,    0,    2,  "&Save Game", SetRet, NULL},
  {d_ex_billbutton_proc, 85,  128,  150,   32,     0,  0,  'c',        0,    0,    3,  "&Controls", SetRet, NULL},
  {d_ex_billbutton_proc, 85,  176,  150,   32,     0,  0,  'q',        0,    0,    0,  "&Quit Options", SetRet, NULL},

  {d_check_exit,          0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL},
  {NULL,                  0,    0,    0,    0,     0,  0,    0,        0,    0,    0,  NULL}
};

int MainMenu() {
  unscare_mouse();

  char temp[40];
  strcpy(temp, "");
  strcat(temp, "JetFight v.");
  strcat(temp, verno);
  strcat(temp, " Main Menu");
  strcpy(verline, temp);

  ret = -1;

  bill_init();
  bill_fade_bmp(screen, 0);
  bill_init_pal();
  set_gui_mode(1);
  centre_dialog(mmdialog);
  init_moveable(mmdialog);
  do_dialog (mmdialog, 0);
  shutdown_moveable(mmdialog);

  scare_mouse();

  return ret;
}

int Options() {
  unscare_mouse();

  char temp[40];
  strcpy(temp, "");
  strcat(temp, "JetFight v.");
  strcat(temp, verno);
  strcat(temp, " Options Menu");
  strcpy(verline, temp);

  ret = -1;

  centre_dialog(odialog);
  init_moveable(odialog);
  do_dialog (odialog, 0);
  shutdown_moveable(odialog);

  scare_mouse();

  return ret;
}

void LoadGame() {
  char filename[80];
  strcpy(filename, "");
  if (billfile_select("Load Game", filename, "SAV")) {
    strlwr(filename);
    Sound.MouseClick(128);

    PACKFILE *mapdata = pack_fopen(filename, F_READ_PACKED);

    if (World.Load(mapdata)) {
      billalert("File Error!", "Current version of", "file not compatable!", "&OK", NULL, 'o', NULL);
      World.Init();
    }

    pack_fclose(mapdata);
  } else {
    Sound.MouseClick(128);
  }
}

void SaveGame() {
  char filename[80];
  strcpy(filename, "");
  if (billfile_select("Save Game", filename, "SAV")) {
    strlwr(filename);
    Sound.MouseClick(128);
    PACKFILE *mapdata = pack_fopen(filename, F_WRITE_PACKED);
    World.Save(mapdata);
    pack_fclose(mapdata);
  } else {
    Sound.MouseClick(128);
  }
}
