//COPYRIGHT(C) 1998 BY JASON WINNEBECK.  YOU MAY FREELY DISTRIBUTE THIS
//SOURCE AND ACCOMPANYING FILES AS LONG AS YOU STILL KEEP THEM ALL TOGETHER,
//YOU DO NOT MODIFY THEM, AND YOU DON'T CLAIM THEM AS YOUR OWN WORK.

#include "jetfight.h"

//                       **************************
//                       ***WEAPONSYSTEM CLASSES***
//                       **************************

int WeaponSystem::Init() {
  for (short c=0; c<pbull; c++) //clear arrays
    pb[c].active = 0;
  for (short c=0; c<ebull; c++)
    eb[c].active = 0;

  currpbull = 0;
  currebull = 0;

  return 0;
}

void WeaponSystem::MakeNewPlayer(float x, float y, float angle, float speed, int color, char timeleft, float damage) {
  pb[currpbull].active = timeleft;
  pb[currpbull].x = x;
  pb[currpbull].y = y;
  pb[currpbull].color = color;
  pb[currpbull].damage = 40.0;
  pb[currpbull].changex = sin(angle * a2rad) * speed;
  pb[currpbull].changey = -cos(angle * a2rad) * speed;
  currpbull++;
  if (currpbull == pbull)
    currpbull = 0;
}

void WeaponSystem::MakeNewEnemy(float x, float y, float angle, float speed, int color, char timeleft, float damage) {
  eb[currebull].active = timeleft;
  eb[currebull].x = x;
  eb[currebull].y = y;
  eb[currebull].color = color;
  eb[currebull].damage = damage;
  eb[currebull].changex = sin(angle * a2rad) * speed;
  eb[currebull].changey = -cos(angle * a2rad) * speed;
  currebull++;
  if (currebull == ebull)
    currebull = 0;
}

void WeaponSystem::Update() {
//UPDATE PLAYER'S BULLETS
  for (short c=0; c<pbull; c++)
    if (pb[c].active) {
      pb[c].x += pb[c].changex; //update pos
      pb[c].y += pb[c].changey;
      Video.DrawBigPixel(int(pb[c].x), int(pb[c].y), pb[c].color); //draw

      pb[c].active--;  //reduce "life"
      if (Enemies.DamageAirEnemies(pb[c].x - 16.0, pb[c].y - 16.0, pb[c].damage))
        //Did we hit something?
        pb[c].active = 0;
    }
//UPDATE ENEMY'S BULLETS
  for (short c=0; c<ebull; c++)
    if (eb[c].active) {
      eb[c].x += eb[c].changex; //update pos
      eb[c].y += eb[c].changey;
      Video.DrawBigPixel(int(eb[c].x), int(eb[c].y), eb[c].color); //draw

      eb[c].active--;  //reduce "life"
      if (Player.Damage(eb[c].x - 16.0, eb[c].y - 16.0, eb[c].damage))
        eb[c].active = 0;
    }
}
